
public class Body {
	private Vector r;
	private Vector v;
	private double m;
	private double radius;
	private static final double G = 6.673/100000000000.0;
	public Body(Vector position,Vector velocity,double mass,double rad){
		r = position;
		v = velocity;
		m = mass;
		radius = rad;
	}
	public Vector pos(){
		return r;
	}
	public Vector vel(){
		return v;
	}
	public void setVel(Vector vel){
	    v = vel;
	}
	public double mass(){
		return m;
	}
	public double radius(){
		return radius;
	}
	public void move(double seconds){
		r.add(v.x()*seconds,v.y()*seconds,v.z()*seconds);
	}
	public void accelerate(double seconds,Vector a){
		v.add(a.x()*seconds,a.y()*seconds,a.z()*seconds);
	}
	public void force(double seconds,Vector f){
		accelerate(seconds,new Vector(f.x()/m,f.y()/m,f.z()/m));
	}
	public void pull(double seconds,Body b){
		Vector dir = Vector.diff(b.pos(),r);
		double p = -G*m/(dir.mag()*dir.mag()*dir.mag());
		dir = Vector.scale(dir,p);
		b.accelerate(seconds,dir);
	}
	public static boolean intersects(Body a,Body b){
		double d = distance(a,b);
		if(d>0){
			return false;
		}
		else{
			return true;
		}
	}
	public static double distance(Body a,Body b){
		double d = Vector.diff(a.pos(),b.pos()).mag();
		double cr = a.radius+b.radius;
		return d-cr;
	}
}
