import java.awt.*;
import java.awt.event.*;
//import java.io.IOException;
import javax.swing.*;
import java.util.*;
public class PlayScreen extends JPanel implements Tickable{
    private Ticker draw;//ID 1, tells when to draw a new frame
    private int msPerFrame = 33;//Milliseconds per frame
    private Bookmark head;
    public PlayScreen(int msStep){
        super();
        setBackground(Color.BLACK);
        
        head = new Bookmark();
        msPerFrame = msStep;
        draw = new Ticker(this,1);
        draw.start(msPerFrame);
        setVisible(true);
    }
    public void paint(Graphics g){
        super.paint(g);
        g.translate(getWidth()/2,getHeight()/2);
        //System.out.println("Paint call to draw board.");
        drawBoard(g);
        //System.out.println("Paint call has drawn board.");
    }
    private void drawBoard(Graphics g){
        //g.setColor(Color.BLACK);
        //g.drawRect(0,0,getWidth()-1,getHeight()-1);
        ShapeNode temp = head;
        for(int i = 1;temp.hasNext();i++){
            temp = temp.getNext();
            temp.drawShape(g);
        }
    }
    public void stop(){
        draw.stop();
    }
    public ShapeNode addNode(Color c, int element, int x, int y, int r){
        ShapeNode temp;
        ShapeNode pre = head.last(element);
        temp = new OvalNode(c, element, x-r, y-r,2*r,2*r);
        temp.setNext(pre.getNext());
        pre.setNext(temp);
        return temp;
    }
    public ShapeNode addNode(Color c, int element, int x, int y, int worxb, int woryb, boolean isLineNotCircle){
        ShapeNode temp;
        ShapeNode pre = head.last(element);
        if(isLineNotCircle){
            temp = new LineNode(c, element, x, y, worxb, woryb);
            temp.setNext(pre.getNext());
            pre.setNext(temp);
        }
        else{
            temp = new OvalNode(c, element, x, y, worxb, woryb);
            temp.setNext(pre.getNext());
            pre.setNext(temp);
        }
        return temp;
    }
    public TextNode addNode(Color c,String text,int element, int x, int y){
        TextNode temp;
        ShapeNode pre = head.last(element);
        temp = new TextNode(c, element, text, x, y);
        temp.setNext(pre.getNext());
        pre.setNext(temp);
        return temp;
    }
    public void remove(ShapeNode s){
        ShapeNode temp = head;
        for(;temp.hasNext();){
            if(temp.getNext()==s){
                temp.removeNext();
            }
            else{
                temp = temp.getNext();
            }
        }
    }
    public void removeAll(int element){
        ShapeNode temp = head;
        for(;temp.hasNext();){
            if(temp.getNext().doesIdentify(element)){
                temp.removeNext();
            }
            else{
                temp = temp.getNext();
            }
        }
    }
    public void removeAll(){
        head.setNext(null);
    }
    public int getHeight(){
        return getSize().height;
    }
    public int getWidth(){
        return getSize().width;
    }
    public void onTick(int id, int iteration){
        switch(id){
            case 1:
            repaint();
            break;
            default:
            break;
        }
    }
}