import java.awt.*;
public class TextNode implements ShapeNode{
    private Color c;
    private ShapeNode next;
    private int element;
    private int x;
    private int y;
    private String text;
    public TextNode(Color color, int inElement, String input,int xi, int yi){
        element = inElement;
        x = xi;
        y = yi;
        c = color;
        text = input;
        next = null;
    }
    public void setText(String s){
        text = s;
    }
    public String getText(){
        return text;
    }
    public void setWidth(int w){}
    public void translate(int xplus, int yplus){
        x+=xplus;
        y+=yplus;
    }
    public void setPos(int xn, int yn){
        x = xn;
        y = yn;
    }
    public void drawShape(Graphics g){
        g.setColor(c);
        g.drawString(text,x,y);
    }
    public void setColor(Color color){
        c = color;
    }
    public Color getColor(){
        return c;
    }
    public void setNext(ShapeNode s){
        next = s;
    }
    public ShapeNode getNext(){
        return next;
    }
    public boolean hasNext(){
        if(next==null){
            return false;
        }
        else{
            return true;
        }
    }
    public boolean hasNextProper(){
        if(!hasNext()){
            return false;
        }
        else{
            if(next.isBookmark()){
                return false;
            }
            else{
                return true;
            }
        }
    }
    public void removeNext(){
        setNext(next.getNext());
    }
    public ShapeNode last(){
        if(next==null){
            return this;
        }
        if(next.isBookmark()){
            return this;
        }
        else{
            return next.last();
        }
    }
    public boolean isBookmark(){
        return false;
    }
    public boolean doesIdentify(int checkElement){
        if(checkElement==element){
            return true;
        }
        else{
            return false;
        }
    }
    public int getElement(){
        return element;
    }
}